<?php

/**
* Clase Dispacher para Cliente
*
* @package IM
* @subpackage ClienteDP
* @author Willy
* @version SVN: : ClienteDP.class.php,v 1.1 2009/05/24 17:57:02 Exp $
*/
class ClienteDP implements interfaceDP {

  protected $o_Bean;

  /**
  * Constructor donde asigna a un atributo el objeto ClienteBean
  *
  * @param ClienteBean $o_ClienteBean
  */
  public function __construct(ClienteBean $o_ClienteBean){
  
    $this->o_Bean = $o_ClienteBean;
    
  }
  
  /**
  * Retorna el objeto ClienteBean
  *
  * @return Object
  */
  protected function getObjetoBean(){
  
    if(!$this->o_Bean){
        $this->o_Bean = new ClienteBean();
    }        
    return $this->o_Bean;
    
  }
  
  /**
  * Ingresa un nuevo registro
  *
  * @return IdGenerado
  */
  public function save(){
    $con = Conexion::getConexion();
      $a_Fields = array();
      
      //if($this->getObjetoBean()->getIdCliente()) : $a_Fields['IdCliente'] = ($this->getObjetoBean()->getIdCliente()); endif;
      if($this->getObjetoBean()->getIdMercado()) : $a_Fields['IdMercado'] = ($this->getObjetoBean()->getIdMercado()); endif;
      if($this->getObjetoBean()->getIdTipoNegocio()) : $a_Fields['IdTipoNegocio'] = ($this->getObjetoBean()->getIdTipoNegocio()); endif;
      if($this->getObjetoBean()->getNombres()) : $a_Fields['Nombres'] = addslashes($this->getObjetoBean()->getNombres()); endif;
      if($this->getObjetoBean()->getApellidoPaterno()) : $a_Fields['ApellidoPaterno'] = addslashes($this->getObjetoBean()->getApellidoPaterno()); endif;
      if($this->getObjetoBean()->getApellidoMaterno()) : $a_Fields['ApellidoMaterno'] = addslashes($this->getObjetoBean()->getApellidoMaterno()); endif;
      if($this->getObjetoBean()->getNombreCompleto()) : $a_Fields['NombreCompleto'] = addslashes($this->getObjetoBean()->getNombreCompleto()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getDireccion()) : $a_Fields['Direccion'] = ($this->getObjetoBean()->getDireccion()); endif;
      if($this->getObjetoBean()->getDireccionNegocio()) : $a_Fields['direccion_negocio'] = addslashes($this->getObjetoBean()->getDireccionNegocio()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getDni()) : $a_Fields['Dni'] = ($this->getObjetoBean()->getDni()); endif;
      if($this->getObjetoBean()->getSexo()) : $a_Fields['Sexo'] = ($this->getObjetoBean()->getSexo()); endif;
      if($this->getObjetoBean()->getEstadoCivil()) : $a_Fields['EstadoCivil'] = ($this->getObjetoBean()->getEstadoCivil()); endif;
      if($this->getObjetoBean()->getFechaNacimiento()) : $a_Fields['FechaNacimiento'] = ($this->getObjetoBean()->getFechaNacimiento()); endif;
      if($this->getObjetoBean()->getTelefono()) : $a_Fields['Telefono'] = ($this->getObjetoBean()->getTelefono()); endif;
      if($this->getObjetoBean()->getCelular()) : $a_Fields['Celular'] = ($this->getObjetoBean()->getCelular()); endif;
      if($this->getObjetoBean()->getOtroTipoNegocio()) : $a_Fields['OtroTipoNegocio'] = addslashes($this->getObjetoBean()->getOtroTipoNegocio()); endif;
      if($this->getObjetoBean()->getCorreo()) : $a_Fields['Correo'] = ($this->getObjetoBean()->getCorreo()); endif;
      
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getTipoDocumento()) : $a_Fields['TipoDocumento'] = ($this->getObjetoBean()->getTipoDocumento()); endif;
      if($this->getObjetoBean()->getDireccionViviendaReal()) : $a_Fields['DireccionViviendaReal'] = addslashes($this->getObjetoBean()->getDireccionViviendaReal()); endif;
      if($this->getObjetoBean()->getReferenciaViviendaReal()) : $a_Fields['ReferenciaViviendaReal'] = addslashes($this->getObjetoBean()->getReferenciaViviendaReal()); endif;
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getJsonReniec()) : $a_Fields['JsonReniec'] = ($this->getObjetoBean()->getJsonReniec()); endif;
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getRucEmpresa()) : $a_Fields['RucEmpresa'] = ($this->getObjetoBean()->getRucEmpresa()); endif;
      if($this->getObjetoBean()->getNombreEmpresa()) : $a_Fields['NombreEmpresa'] = ($this->getObjetoBean()->getNombreEmpresa()); endif;
      if($this->getObjetoBean()->getDireccionEmpresa()) : $a_Fields['DireccionEmpresa'] = ($this->getObjetoBean()->getDireccionEmpresa()); endif;
      if($this->getObjetoBean()->getDniGerente()) : $a_Fields['DniGerente'] = ($this->getObjetoBean()->getDniGerente()); endif;
      if($this->getObjetoBean()->getNombresGerente()) : $a_Fields['NombresGerente'] = ($this->getObjetoBean()->getNombresGerente()); endif;
      if($this->getObjetoBean()->getApellidoPaternoGerente()) : $a_Fields['ApellidoPaternoGerente'] = ($this->getObjetoBean()->getApellidoPaternoGerente()); endif;
      if($this->getObjetoBean()->getApellidoMaternoGerente()) : $a_Fields['ApellidoMaternoGerente'] = ($this->getObjetoBean()->getApellidoMaternoGerente()); endif;
      
      if($this->getObjetoBean()->getLongitudDomicilio()) : $a_Fields['LongitudDomicilio'] = ($this->getObjetoBean()->getLongitudDomicilio()); endif;
      if($this->getObjetoBean()->getLatitudDomicilio()) : $a_Fields['LatitudDomicilio'] = ($this->getObjetoBean()->getLatitudDomicilio()); endif;
      if($this->getObjetoBean()->getLongitudNegocio()) : $a_Fields['LongitudNegocio'] = ($this->getObjetoBean()->getLongitudNegocio()); endif;
      if($this->getObjetoBean()->getLatitudNegocio()) : $a_Fields['LatitudNegocio'] = ($this->getObjetoBean()->getLatitudNegocio()); endif;
      
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
      
      $sStringField = arrayClass::implode_keys(',', $a_Fields);
      $sStringValue = "'".implode("','", $a_Fields)."'";

      $sql = "INSERT INTO cr_cliente (".$sStringField.")
                      VALUES (".$sStringValue.");";
	  //echo $sql;
      mysql_db_query(Conexion::getNameDb(), 'SET NAMES utf8', $con);
      $iResultSave = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $iResul = mysql_insert_id($con);
      
      if($iResul > 0){
        return $iResul;
      }else{
        return false;
      }
  
  }
  
  /**
  * Modifica un nuevo registro
  *
  * @return IdGenerado
  */
  public function update() {

    if($this->getObjetoBean()->getIdCliente()){
      $con = Conexion::getConexion();
      $a_Fields = array();
      
      if($this->getObjetoBean()->getIdCliente()) : $a_Fields['IdCliente'] = ($this->getObjetoBean()->getIdCliente()); endif;
      if($this->getObjetoBean()->getIdMercado()) : $a_Fields['IdMercado'] = ($this->getObjetoBean()->getIdMercado()); endif;
      if($this->getObjetoBean()->getIdTipoNegocio()) : $a_Fields['IdTipoNegocio'] = ($this->getObjetoBean()->getIdTipoNegocio()); endif;
      if($this->getObjetoBean()->getNombres()) : $a_Fields['Nombres'] = addslashes($this->getObjetoBean()->getNombres()); endif;
      if($this->getObjetoBean()->getApellidoPaterno()) : $a_Fields['ApellidoPaterno'] = addslashes($this->getObjetoBean()->getApellidoPaterno()); endif;
      if($this->getObjetoBean()->getApellidoMaterno()) : $a_Fields['ApellidoMaterno'] = addslashes($this->getObjetoBean()->getApellidoMaterno()); endif;
      if(trim($this->getObjetoBean()->getNombreCompleto()) != ",") : $a_Fields['NombreCompleto'] = addslashes($this->getObjetoBean()->getNombreCompleto()); endif;
      if($this->getObjetoBean()->getEstado()) : $a_Fields['Estado'] = ($this->getObjetoBean()->getEstado()); endif;
      if($this->getObjetoBean()->getDireccion()) : $a_Fields['Direccion'] = ($this->getObjetoBean()->getDireccion()); endif;
      if($this->getObjetoBean()->getDireccionNegocio()) : $a_Fields['direccion_negocio'] = ($this->getObjetoBean()->getDireccionNegocio()); endif;
      if($this->getObjetoBean()->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getObjetoBean()->getUsuarioCreacion()); endif;
      if($this->getObjetoBean()->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getObjetoBean()->getFechaCreacion()); endif;
      if($this->getObjetoBean()->getUsuarioModificacion()) : $a_Fields['UsuarioModificacion'] = ($this->getObjetoBean()->getUsuarioModificacion()); endif;
      if($this->getObjetoBean()->getFechaModificacion()) : $a_Fields['FechaModificacion'] = ($this->getObjetoBean()->getFechaModificacion()); endif;
      if($this->getObjetoBean()->getEliminado()) : $a_Fields['Eliminado'] = ($this->getObjetoBean()->getEliminado()); endif;
      if($this->getObjetoBean()->getFechaEliminado()) : $a_Fields['FechaEliminado'] = ($this->getObjetoBean()->getFechaEliminado()); endif;
      if($this->getObjetoBean()->getDni()) : $a_Fields['Dni'] = ($this->getObjetoBean()->getDni()); endif;
      if($this->getObjetoBean()->getSexo()) : $a_Fields['Sexo'] = ($this->getObjetoBean()->getSexo()); endif;
      if($this->getObjetoBean()->getEstadoCivil()) : $a_Fields['EstadoCivil'] = ($this->getObjetoBean()->getEstadoCivil()); endif;
      if($this->getObjetoBean()->getFechaNacimiento()) : $a_Fields['FechaNacimiento'] = ($this->getObjetoBean()->getFechaNacimiento()); endif;
      if($this->getObjetoBean()->getTelefono()) : $a_Fields['Telefono'] = ($this->getObjetoBean()->getTelefono()); endif;
      if($this->getObjetoBean()->getCelular()) : $a_Fields['Celular'] = ($this->getObjetoBean()->getCelular()); endif;
      if($this->getObjetoBean()->getOtroTipoNegocio()) : $a_Fields['OtroTipoNegocio'] = ($this->getObjetoBean()->getOtroTipoNegocio()); endif;
      if($this->getObjetoBean()->getCorreo()) : $a_Fields['Correo'] = ($this->getObjetoBean()->getCorreo()); endif;
      
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getTipoDocumento()) : $a_Fields['TipoDocumento'] = ($this->getObjetoBean()->getTipoDocumento()); endif;
      if($this->getObjetoBean()->getDireccionViviendaReal()) : $a_Fields['DireccionViviendaReal'] = addslashes($this->getObjetoBean()->getDireccionViviendaReal()); endif;
      if($this->getObjetoBean()->getReferenciaViviendaReal()) : $a_Fields['ReferenciaViviendaReal'] =addslashes ($this->getObjetoBean()->getReferenciaViviendaReal()); endif;
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getJsonReniec()) : $a_Fields['JsonReniec'] = ($this->getObjetoBean()->getJsonReniec()); endif;
      if($this->getObjetoBean()->getFechaCaducidadDoc()) : $a_Fields['FechaCaducidadDoc'] = ($this->getObjetoBean()->getFechaCaducidadDoc()); endif;
      if($this->getObjetoBean()->getRucEmpresa()) : $a_Fields['RucEmpresa'] = ($this->getObjetoBean()->getRucEmpresa()); endif;
      if($this->getObjetoBean()->getNombreEmpresa()) : $a_Fields['NombreEmpresa'] = ($this->getObjetoBean()->getNombreEmpresa()); endif;
      if($this->getObjetoBean()->getDireccionEmpresa()) : $a_Fields['DireccionEmpresa'] = ($this->getObjetoBean()->getDireccionEmpresa()); endif;
      if($this->getObjetoBean()->getDniGerente()) : $a_Fields['DniGerente'] = ($this->getObjetoBean()->getDniGerente()); endif;
      if($this->getObjetoBean()->getNombresGerente()) : $a_Fields['NombresGerente'] = ($this->getObjetoBean()->getNombresGerente()); endif;
      if($this->getObjetoBean()->getApellidoPaternoGerente()) : $a_Fields['ApellidoPaternoGerente'] = ($this->getObjetoBean()->getApellidoPaternoGerente()); endif;
      if($this->getObjetoBean()->getApellidoMaternoGerente()) : $a_Fields['ApellidoMaternoGerente'] = ($this->getObjetoBean()->getApellidoMaternoGerente()); endif;
      
      if($this->getObjetoBean()->getLongitudDomicilio()) : $a_Fields['LongitudDomicilio'] = ($this->getObjetoBean()->getLongitudDomicilio()); endif;
      if($this->getObjetoBean()->getLatitudDomicilio()) : $a_Fields['LatitudDomicilio'] = ($this->getObjetoBean()->getLatitudDomicilio()); endif;
      if($this->getObjetoBean()->getLongitudNegocio()) : $a_Fields['LongitudNegocio'] = ($this->getObjetoBean()->getLongitudNegocio()); endif;
      if($this->getObjetoBean()->getLatitudNegocio()) : $a_Fields['LatitudNegocio'] = ($this->getObjetoBean()->getLatitudNegocio()); endif;
      
      if($this->getObjetoBean()->getGastoAdministrativoPorcentaje()) : $a_Fields['GastoAdministrativoPorcentaje'] = ($this->getObjetoBean()->getGastoAdministrativoPorcentaje()); endif;
      
      if($this->getObjetoBean()->getFlagConHuella()) : $a_Fields['FlagConHuella'] = ($this->getObjetoBean()->getFlagConHuella()); endif;
      if($this->getObjetoBean()->getFlagHuellaConProblema()) : $a_Fields['FlagHuellaConProblema'] = ($this->getObjetoBean()->getFlagHuellaConProblema()); endif;
      
      if($this->getObjetoBean()->getUsuarioEliminado()) : $a_Fields['UsuarioEliminado'] = ($this->getObjetoBean()->getUsuarioEliminado()); endif;
      $a_Fields['flagCC'] = '-1';
      $sString = arrayClass::implode_key_value(",", $a_Fields);

      $sql = "UPDATE cr_cliente SET
                  ".$sString."
            WHERE 1 AND IdCliente= '".$this->getObjetoBean()->getIdCliente()."' ";
        mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
	mysql_query("SET character_set_results=utf8", $con);
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      
                  
      $iResultSave = $result;
      if($iResultSave > 0){
        return $iResultSave;
      }else{
        return false;
      }

    }else{
      return false;
    }

  }
  
  
  /**
  * Elimina registro
  *
  * @return Boolean
  */
   public function delete(){
    
      $o_Cliente = new ClienteBean();
      
      $con = Conexion::getConexion();
      
      if($this->getObjetoBean()->getIdCliente()){
          $o_Cliente->setIdCliente($this->getObjetoBean()->getIdCliente());
      }
            
      $sql = "UPDATE cr_cliente 
              SET
                Eliminado = '1',
                FechaEliminado = '".date('Y-m-d H:i:s')."',
                UsuarioEliminado = '".$this->getObjetoBean()->getUsuarioEliminado()."'
            WHERE IdCliente= '".$this->getObjetoBean()->getIdCliente()."' ";
      
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      
      $num_rows = mysql_affected_rows($con);
      
                  
      $iResultDelete = $num_rows;
      if($iResultDelete){
          return 1;
      }else{
          return false;
      }    
    
  }
  /**
  * Selecciona un nuevo registro
  *
  * @return IdGenerado
  */
  public function select($sql_ext=''){
      
    $where = "";
        
    $tamPag           = is_null($this->getObjetoBean()->tamPag)?999999:$this->getObjetoBean()->tamPag;
    $pagina           = is_null($this->getObjetoBean()->page)?1:$this->getObjetoBean()->page;
    $numeroRegistros  = $this->selectNumRows($sql_ext);
    $limitInf         = ($pagina-1)*$tamPag;
    
    $where = $this->buildConsult();
    $orden = $this->buildOrderByField();
    //if(trim($orden) =='') $orden = "ORDER BY nombres,ApellidoPaterno,ApellidoMaterno DESC";
    if(trim($orden) =='') $orden = "ORDER BY IdCliente DESC";
    $con = Conexion::getConexion();
     
    
    if($sql_ext){
    	 $sql = "SELECT * 
    		FROM cr_cliente
            WHERE 1 = 1 ".$where." ".$orden;
    	//$sql = "(".$sql_ext.") UNION DISTINCT (".$sql.") LIMIT ".$limitInf.",".$tamPag;
    	$sql = "(".$sql_ext.") LIMIT ".$limitInf.",".$tamPag;
    }else{
    	$sql = "SELECT * 
    		FROM cr_cliente
            WHERE 1 = 1 ".$where." ".$orden." LIMIT ".$limitInf.",".$tamPag;
    }
   //echo $sql;
	mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
	mysql_query("SET character_set_results=utf8", $con);
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    //echo $sql;
    $a_tmp = array();

    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      $a_tmp[] = $this->insertarObjetoBean($o_valor);
      }
    }
    
    

    //
   
    return count($a_tmp)>0?$a_tmp:null;
      
  }  
  
  public function ultimoInteres(){
  	 $con = Conexion::getConexion();
    $sql = "SELECT InteresPorcentaje 
            FROM cr_prestamo
            WHERE 1=1 and  IdCliente = '".$this->getObjetoBean()->getIdCliente()."' 
            order by IdPrestamo desc
            Limit 0,1";
    
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
     
   
    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      	return $o_valor->InteresPorcentaje;
      }
    }
       
    return 0;
  }
  
   
  /**
  * Retorna un objeto ClienteBean
  *
  * @return Object
  */
  public function selectByPk(){
  
    $con = Conexion::getConexion();
    $sql = "SELECT * 
            FROM cr_cliente
            WHERE 1=1 and  IdCliente = '".$this->getObjetoBean()->getIdCliente()."' ";
    mysql_db_query(Conexion::getNameDb(), "SET NAMES 'utf8'", $con);
	mysql_query("SET character_set_results=utf8", $con);
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
  
   
    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
      $a_tmp[] = $this->insertarObjetoBean($o_valor);
      }
    }
       
    return count($a_tmp)>0?$a_tmp:null;
      
  }
  
  /**
  * Reasigna valores retornados del propel a un objeto ClienteBean
  *
  * @param Object $o_Propel
  * @return ClienteBean
  */
  private function insertarObjetoBean($o_Propel){

    $o_ClienteBean = new ClienteBean();
    
    $o_ClienteBean->setIdCliente($o_Propel->IdCliente);
    $o_ClienteBean->setIdMercado($o_Propel->IdMercado);
    $o_ClienteBean->setIdTipoNegocio($o_Propel->IdTipoNegocio);
    $o_ClienteBean->setNombres($o_Propel->Nombres);
    $o_ClienteBean->setApellidoPaterno($o_Propel->ApellidoPaterno);
    $o_ClienteBean->setApellidoMaterno($o_Propel->ApellidoMaterno);
    $o_ClienteBean->setNombreCompleto($o_Propel->NombreCompleto);
    $o_ClienteBean->setEstado($o_Propel->Estado);
    $o_ClienteBean->setDireccion($o_Propel->Direccion);
    $o_ClienteBean->setUsuarioCreacion($o_Propel->UsuarioCreacion);
    $o_ClienteBean->setFechaCreacion($o_Propel->FechaCreacion);
    $o_ClienteBean->setUsuarioModificacion($o_Propel->UsuarioModificacion);
    $o_ClienteBean->setFechaModificacion($o_Propel->FechaModificacion);
    $o_ClienteBean->setEliminado($o_Propel->Eliminado);
    $o_ClienteBean->setFechaEliminado($o_Propel->FechaEliminado);
    $o_ClienteBean->setDni($o_Propel->Dni);
    $o_ClienteBean->setTipoDocumento($o_Propel->TipoDocumento);
    $o_ClienteBean->setSexo($o_Propel->Sexo);
    $o_ClienteBean->setEstadoCivil($o_Propel->EstadoCivil);
    $o_ClienteBean->setFechaNacimiento($o_Propel->FechaNacimiento);
    $o_ClienteBean->setTelefono($o_Propel->Telefono);
    $o_ClienteBean->setCelular($o_Propel->Celular);
    $o_ClienteBean->setOtroTipoNegocio($o_Propel->OtroTipoNegocio);
    $o_ClienteBean->setCorreo($o_Propel->Correo);
    
    
    $o_ClienteBean->setTipoDocumento($o_Propel->TipoDocumento);
    $o_ClienteBean->setFechaCaducidadDoc($o_Propel->FechaCaducidadDoc);
    $o_ClienteBean->setDireccionViviendaReal($o_Propel->DireccionViviendaReal);
    $o_ClienteBean->setReferenciaViviendaReal($o_Propel->ReferenciaViviendaReal);
    $o_ClienteBean->setJsonReniec($o_Propel->JsonReniec);
    $o_ClienteBean->setRucEmpresa($o_Propel->RucEmpresa);
    $o_ClienteBean->setNombreEmpresa($o_Propel->NombreEmpresa);
    $o_ClienteBean->setDireccionEmpresa($o_Propel->DireccionEmpresa);
    $o_ClienteBean->setDniGerente($o_Propel->DniGerente);
    $o_ClienteBean->setNombresGerente($o_Propel->NombresGerente);
    $o_ClienteBean->setApellidoPaternoGerente($o_Propel->ApellidoPaternoGerente);
    $o_ClienteBean->setApellidoMaternoGerente($o_Propel->ApellidoMaternoGerente);
       
    
    $o_ClienteBean->setLongitudDomicilio($o_Propel->LongitudDomicilio);
    $o_ClienteBean->setLatitudDomicilio($o_Propel->LatitudDomicilio);
    $o_ClienteBean->setLongitudNegocio($o_Propel->LongitudNegocio);
    $o_ClienteBean->setLatitudNegocio($o_Propel->LatitudNegocio);
	$o_ClienteBean->setDireccionNegocio($o_Propel->direccion_negocio);
    $o_ClienteBean->setUsuarioEliminado($o_Propel->UsuarioEliminado);
    $o_ClienteBean->setFlagConHuella($o_Propel->flagConHuella);
    $o_ClienteBean->setFlagHuellaConProblema($o_Propel->FlagHuellaConProblema);
    $o_ClienteBean->setSemaforo($this->getSemaforoUltimoPrestamo($o_Propel->IdCliente));
    $o_ClienteBean->setGastoAdministrativoPorcentaje($o_Propel->GastoAdministrativoPorcentaje);
    $o_ClienteBean->setFlagCentralRiesgo($o_Propel->FlagCentralRiesgo);
         
    return $o_ClienteBean;    
    
  }
  
  public function selectNumRows($sql_ext=''){
    $where = $this->buildConsult(); 
    $con = Conexion::getConexion();
     
    if($sql_ext){
    	$sql = "(".$sql_ext.")";
    }else{
    	$sql = "SELECT * 
	    		FROM cr_cliente
	    		WHERE 1 = 1 ".$where;
    }  
     
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    
    return $num_rows;
    
  }
  
  public function TienePrestamo(){
  	if($this->getObjetoBean()->getFechaInicioPrestamo())$where = "and FechaInicio = '".$this->getObjetoBean()->getFechaInicioPrestamo()."'";
  	if($this->getObjetoBean()->getEstado())$where = "and Estado = '".$this->getObjetoBean()->getEstado()."'";
  	$con = Conexion::getConexion();
    $sql = "SELECT * 
    		FROM cr_prestamo
            WHERE Eliminado <> '1' 
    		 	$where
    		and  IdCliente = '".$this->getObjetoBean()->getIdCliente()."'";
    
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    $a_tmp = array();

    if($num_rows>0){
     return true;
    }
    return false;
  }
  
  public function getSemaforoUltimoPrestamo($idcliente){
    $where = " and  idcliente = '".$idcliente."'"; 
    $con = Conexion::getConexion();
     
    
    	$sql = "SELECT semaforo 
	    		FROM cr_prestamo
	    		WHERE 1 = 1 ".$where." 
	    		ORDER BY 1 desc
    			LIMIT 0,1";
    	;
    	//echo $sql;
    
    $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    $num_rows = mysql_num_rows($result);
    
    $num_rows = mysql_num_rows($result);
     
   
    if($num_rows>0){
      while ($o_valor = mysql_fetch_object($result)) {
       return $o_valor->semaforo;
      }
    }
    return "";
  }
  
  public function seleccionarClientesReCaptacion($idSucursal,$idMercado,$idColaborador=''){
  	$con = Conexion::getConexion();
  

	if($idSucursal){
		$where = " and idsucursal = '".$idSucursal."' ";
	}
	
	//Buscar todas las sucursales
	
	$sql = "select IdAdministrador,IdSucursal 
			from `cr_sucursal`
			WHERE Estado = 'A' $where and eliminado = '0'
			";
	
	$result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
	$num_rows = mysql_num_rows($result);
	
	if($num_rows>0){
	  while ($o_valor = mysql_fetch_object($result)) {
	  	$IdAdministrador = $o_valor->IdAdministrador;
	  	$IdSucursal = $o_valor->IdSucursal;
	  	//Buscar todos los mercados x cada sucursal
	  	if($idSucursal){
			$where = " and sm.idsucursal = '".$idSucursal."' ";
		}
		
		if($idMercado){
			$where .= " and m.IdMercado = '".$idMercado."' ";
		}
	
	  	$sql = "select m.IdMercado   
				from `cr_sucursal_mercado` sm
				left join cr_mercado m on m.IdMercado = sm.IdMercado
				WHERE 1=1 $where and m.eliminado = '0'
				";
	
	  	$resultms = mysql_db_query(Conexion::getNameDb(), $sql, $con);
		$num_rowsms = mysql_num_rows($resultms);
		 while ($o_valorms = mysql_fetch_object($resultms)) {
			if($num_rowsms > 0){
				$IdMercado = $o_valorms->IdMercado;
				//Buscar los colabaoradores x cada administrador
		  		$sql = "select IdCliente,NombreCompleto
					from `cr_cliente` c
					WHERE idMercado = '$IdMercado'
						and c.eliminado ='0'
						
					";
			//Limit 0 , 40
		  	
			  	$resultcli = mysql_db_query(Conexion::getNameDb(), $sql, $con);
				$num_rowscli = mysql_num_rows($resultcli);
				if($num_rowscli > 0){
					 while ($o_valorcli = mysql_fetch_object($resultcli)) {
				  		$IdCliente = $o_valorcli->IdCliente;
				  		$NombreCliente = $o_valorcli->NombreCompleto;
				  		//Buscar los prestamos vencidos
					  	$sql = "select c.IdCliente ,p.estado,max(fechaVencimiento) as fechaMax,max(FechaCancelacion) as fechaMaxC,count(*) as cantidad
								from `cr_prestamo` p
								left join cr_cliente c on c.idcliente = p.idcliente
								WHERE c.IdCliente = '$IdCliente'
								and p.eliminado = '0'
								and c.eliminado = '0'
								group by c.IdCliente, p.estado
								
								";
					  	if($IdCliente == '6005'){
					  			//echo "ok".$sql."<br>";	
					  	}
					  	$resultpre = mysql_db_query(Conexion::getNameDb(), $sql, $con);
						$num_rowspre = mysql_num_rows($resultpre);
						if($num_rowspre > 0){
							 while ($o_valorpre = mysql_fetch_object($resultpre)) {
								$IdCliente = $o_valorpre->IdCliente;
								$Estado = $o_valorpre->estado;
								$cantidad = $o_valorpre->cantidad;
								$fechaMax = $o_valorpre->fechaMax;
								$fechaMaxC = $o_valorpre->fechaMaxC;
								
								$a_cliente[$IdCliente][$Estado] = $cantidad;
								
								if($Estado == 'C' && $fechaMaxC){
									$a_cliente[$IdCliente]['fechaMaximo'] = $fechaMax;
									$a_cliente[$IdCliente]['fechaMaximoCancelado'] = $fechaMaxC;
									$a_cliente[$IdCliente]['IdMercado'] = $IdMercado;
									$a_cliente[$IdCliente]['IdSucursal'] = $IdSucursal;
									$a_cliente[$IdCliente]['NombreCliente'] = $NombreCliente;
									
								}
								
								/*if($IdCliente == '6005'){
									echo "<pre>";
									print_r($a_cliente);	
									echo "</pre>";
								}*/
			
							}
						
						}
						 
					 }
				 }
				 
			   }
			  
			}
			if(is_array($a_cliente)){
				foreach ($a_cliente as $keyc => $a_cliente ){
					//echo $a_cliente['fechaMaximoCancelado'];
					if(!$a_cliente['P'] && diferenciaDates(date('Y-m-d'),substr($a_cliente['fechaMaximoCancelado'],0,10))>20){
						$a_cliente_depurado[$keyc] = $a_cliente;
					}
				}
			}
	 	}
		
		//echo count($a_cliente_depurado);
		$a_clientes = array_sort($a_cliente_depurado, 'fechaMaximoCancelado', SORT_DESC);
		return $a_clientes;		
	}
  	
  }
  
  private function buildConsult(){
    
    $where = "";
     $where_eliminado = " AND cr_cliente.Eliminado <> '1'";
     
    if($this->getObjetoBean()->getIdCliente()){
       $where .= " AND cr_cliente.IdCliente = '".$this->getObjetoBean()->getIdCliente()."'";
    }
    if($this->getObjetoBean()->getIdMercado()){
       $where .= " AND IdMercado = '".$this->getObjetoBean()->getIdMercado()."'";
    }
    
    if($this->getObjetoBean()->getEstado()){
       $where .= " AND cr_cliente.Estado  = '".$this->getObjetoBean()->getEstado()."'";
    }
    if($this->getObjetoBean()->getIdTipoNegocio()){
       $where .= " AND IdTipoNegocio  = '".$this->getObjetoBean()->getIdTipoNegocio()."'";
    }
    if($this->getObjetoBean()->getApellidoPaterno()){
       $where .= " AND ApellidoPaterno like '".$this->getObjetoBean()->getApellidoPaterno()."%'";
    }
    if($this->getObjetoBean()->getFlagConHuella()){
       $where .= " AND FlagConHuella = '".$this->getObjetoBean()->getFlagConHuella()."'";
    }
    if($this->getObjetoBean()->getApellidoMaterno()){
       $where .= " AND ApellidoMaterno like '".$this->getObjetoBean()->getApellidoMaterno()."%'";
    }
    if($this->getObjetoBean()->getNotIdCliente()){
       $where .= " AND cr_cliente.IdCliente <> '".$this->getObjetoBean()->getNotIdCliente()."'";
    }
    if($this->getObjetoBean()->getNombres()){
       $where .= " AND Nombres like '%".$this->getObjetoBean()->getNombres()."%'";
    }
    if($this->getObjetoBean()->getTipodocumento()){
       $where .= " AND TipoDocumento like '".$this->getObjetoBean()->getTipodocumento()."'";
    }
	if($this->getObjetoBean()->getDni()){
       $where .= " AND dni like '".$this->getObjetoBean()->getDni()."'";
    }
    if($this->getObjetoBean()->getSexo()){
       $where .= " AND Sexo  = '".$this->getObjetoBean()->getSexo()."'";
    }
    if($this->getObjetoBean()->getGastoAdministrativoPorcentaje()){
       $where .= " AND GastoAdministrativoPorcentaje  = '".$this->getObjetoBean()->getGastoAdministrativoPorcentaje()."'";
    }
    if($this->getObjetoBean()->getUsuarioCreacion()){
       $where .= " AND UsuarioCreacion  = '".$this->getObjetoBean()->getUsuarioCreacion()."'";
    }
    if($this->getObjetoBean()->getEliminado()){
      	 $where_eliminado = " AND cr_cliente.Eliminado  = '1'";
    }
    if(is_array($this->getObjetoBean()->getFiltroMercado())){
      	 $where .= " AND IdMercado in ('".implode("','",$this->getObjetoBean()->getFiltroMercado())."')";
    }
     return $where_eliminado." ". $where;
    
  }
  
   public function buildOrderByField(){
    $order_by = "";
    if($this->getObjetoBean()->sortCampos || $this->getObjetoBean()->sortCampos != ""){
      $a_valCampos = explode(";", $this->getObjetoBean()->sortCampos);
      $a_valtype   = explode(";", $this->getObjetoBean()->sortType);
      $order_by = " ORDER BY ";
      $a_order = array();
      foreach ($a_valCampos as $key => $val){
        $sTmpOrder = "";
        if(array_key_exists($val, self::$fieldNames)){
          $sTmpOrder .= self::$fieldNames[$val];
          switch ($a_valtype[$key]){
            case 1: $sTmpOrder .= " ASC"; break;
            case 2: $sTmpOrder .= " DESC"; break;
          }
          $a_order[] = $sTmpOrder;
        }
      }
      $order_by .= implode(", ", $a_order);
    }
    return $order_by;
  }
    
    
}

